#include "session_daemon.h"
#include "properties.h"

#include "horde_log.h"

//
// properties stuff
//
properties horde_properties;
  
bool 
horde::load_properties_file(const string& filename) {
  int err = horde_properties.read_from_file(filename);

  return !(err < 0);
}

int horde::count_properties() {
  return horde_properties.size();
}
  
string 
horde::get_property(string property, string default_value) {
  return horde_properties.get(property, default_value);
}
  
void 
horde::set_property(string property, string value) {
  horde_properties.set(property, value);
}
