// -*- mode: C++; -*-

#ifndef __HORDE_STRING_HASHMAP_H__
#define __HORDE_STRING_HASHMAP_H__

#include <ext/hash_map>
#include <string>
#include <vector>

using namespace __gnu_cxx; // for hashmap..
using namespace std; // for string

struct string_hash {
  size_t operator()(const std::string& __x) const {
    return __stl_hash_string(__x.c_str());
  }
};

typedef hash_map<string, string, string_hash> string_string_hashmap_t;

#define STRING_HASHMAP(T) hash_map<string,T,string_hash>

// // lookup element with 'key' in 'hmap', and return the associated value, 
// // or 'fail_retval' if no matching key found in the hashmap.
// template<typename T> 
// T strhashmap_lookup(hashmap<string,T,string_hash> hmap, const string& key, T fail_retval) {

//   hashmap<string,T,string_hash>::const_iterator val = hmap.find(key);

//   if (val != hmap.end()) {
//     return val->second;
//   } else {
//     return fail_retval;
//   }
// }

// // lookup element with 'key' in 'hmap', return the associated value, 
// // and delete the element from the hashmap, or return 'fail_retval' and 
// // remove nothing if no matching key found in the hashmap.
// template<typename T> 
// T strhashmap_find_and_erase(hashmap<string,T,string_hash> hmap, const string& key, T fail_retval) {

//   hashmap<string,T,string_hash>::iterator value = hmap.find(key);

//   if (val != hmap.end()) {
//     T retval = val->second;
//     val.erase();
//     return retval;
//   } else {
//     return fail_retval;
//   }
// }

#endif
