#ifndef __TRIBE_IFMANAGER_SPAWN__
#define __TRIBE_IFMANAGER_SPAWN__

#include <vector>
#include <string>

using namespace std;

extern int if_max_retry;
extern int if_retry_reset_period;
extern int if_retry_sleep;
extern bool if_reset_all;

typedef void(*exit_handler_t)();

void ifmanagers_start_all(vector<string>& managed_ifaces, exit_handler_t h);
void ifmanagers_kill_all();
void ifmanagers_poll();

#endif
