#!/usr/bin/python

suppress_make_main = True

exec file("../scripts/make.py")

COMPILER_WRAPPER="../scripts/wtf"
TARGET = "tribe_leader"
SRC_FILES = ["leader/leader.cc", "leader/tun_device.c", "leader/tun_manager.cc",
             "common/util.cc", "../nmstl/internal.cc", "../nmstl/debug.cc"] 
INCLUDE_PATHS = [".", "common", "../nmstl"]
OBJ_FILE_DIR = "obj"
LINKER_FLAGS = "-lstdc++"

def main():    
    if len(sys.argv) > 1:
        if sys.argv[1] in ["clean", "x", "rebuild"]:
            add_macro_definitions(sys.argv[2:])
            
            if sys.argv[1] == "clean":
                make_clean(SRC_FILES)
            elif sys.argv[1] == "x" or sys.argv[1] == "rebuild":
                make_clean(SRC_FILES)
                make_binary(TARGET, SRC_FILES, INCLUDE_PATHS)
        else:
            add_macro_definitions(sys.argv[1:])
            make_binary(TARGET, SRC_FILES, INCLUDE_PATHS)
    else:
        make_binary(TARGET, SRC_FILES, INCLUDE_PATHS)

main()
